$(document).ready(function(){
    
    // jquery cookie plugin, code shared from
    var cookie=function(key,value,options){if(arguments.length>1&&(!/Object/.test(Object.prototype.toString.call(value))||value===null||value===undefined)){options=$.extend({},options);if(value===null||value===undefined){options.expires=-1}if(typeof options.expires==='number'){var days=options.expires,t=options.expires=new Date();t.setDate(t.getDate()+days)}value=String(value);return(document.cookie=[encodeURIComponent(key),'=',options.raw?value:encodeURIComponent(value),options.expires?'; expires='+options.expires.toUTCString():'',options.path?'; path='+options.path:'',options.domain?'; domain='+options.domain:'',options.secure?'; secure':''].join(''))}options=value||{};var decode=options.raw?function(s){return s}:decodeURIComponent;var pairs=document.cookie.split('; ');for(var i=0,pair;pair=pairs[i]&&pairs[i].split('=');i++){if(decode(pair[0])===key)return decode(pair[1]||'')}return null};

    var ACTIVE_MENU = window.TOPBAR_ACTIVE_SERVICE || 'cloud';
    var USER_DATA = window.TOPBAR_USER_DATA || {'user': 'test@grnet.gr', 'logged_in': false};

    var TOPBAR_LOC = "http://servicesbar.cloud.grnet.gr/";
    
    // load css
    var css = $("<link />");
    css.attr({rel:'stylesheet', type:'text/css', href:TOPBAR_LOC + 'servicesbar.css'});
    $("head").append(css);

    // load service specific css
    var SKIP_ADDITIONAL_CSS = window.SKIP_ADDITIONAL_CSS == undefined ? false : window.SKIP_ADDITIONAL_CSS;

    if (!SKIP_ADDITIONAL_CSS) {
        var css = $("<link />");
        css.attr({rel:'stylesheet', type:'text/css', href:TOPBAR_LOC + ACTIVE_MENU + '.css'});
        $("head").append(css);
    }

    var root = $('body');
    var bar = $('<div class="servicesbar"></div>');
    var services = $('<div class="services"></div>');
    var profile = $('<div class="profile"></div>');
    
    var SERVICES_LINKS = {
        'cloud':   { url:'http://cloud.grnet.gr/', name:'grnet cloud', id:'cloud', icon:'home-icon.png' },
        'okeanos': { url:'http://okeanos.cloud.grnet.gr', name:'~okeanos', id:'okeanos' },
        'pithos':  { url:'http://pithos.cloud.grnet.gr', name:'pithos+', id:'pithos' },
    };
    
    var PROFILE_URL = "https://accounts.cloud.grnet.gr";

    var home_icon_data = "";
    var PROFILE_LINKS = {
        'login': { url: '/accounts/login', auth:false, name: "login..." },
        'forgot_pass': { url: '/accounts/recover', auth:false, name: "recover your password..." },
        'profile': { url: '/accounts/myprofile', auth:true, name: "my profile..." },
        'change_pass': { url: '/accounts/changepassword', auth:true, name: "change your password..." },
        'invitations': { url: '/accounts/invitations', auth:true, name: "invite some friends..." },
    };

    $.each(SERVICES_LINKS, function(i, el){
        var slink = $("<a>");
        if (el.icon) {
            slink.append($('<img src="'+TOPBAR_LOC+el.icon+'"/>'));
        } else {
            slink.text(el.name);
        }
        slink.attr('href', el.url);
        slink.attr('title', el.name);
        services.append(slink);
        if (el.id == ACTIVE_MENU) {
            slink.addClass("active");
        }
    });
    
    // user profile menu
    var USERNAME = USER_DATA.user;
    var LOGGED_IN = USER_DATA.logged_in;

    var user = $('<div class="user"></div>');
    var username = $('<a href="#"></a>');
    username.text(USERNAME);
    var usermenu = $("<ul>");

    $.each(PROFILE_LINKS, function(i,el) {
        var li = $("<li />");
        var link = $("<a />");
        link.text(el.name);
        link.attr({href:el.url});
        li.append(link);
        usermenu.append(li);
    });
    
    user.append(username);
    user.append(usermenu);
    profile.append(user);
    bar.append(services).append(profile);
    root.prepend(bar);
});
